LightOJ 1422 Halloween Costumes

2024-03-24 07:38

本文主要是介绍LightOJ 1422 Halloween Costumes,希望对大家解决编程问题提供一定的参考价值,需要的开发者们随着小编来一起学习吧!

原题:
Gappu has a very busy weekend ahead of him. Because, next weekend is Halloween, and he is planning to attend as many parties as he can. Since it’s Halloween, these parties are all costume parties, Gappu always selects his costumes in such a way that it blends with his friends, that is, when he is attending the party, arranged by his comic-book-fan friends, he will go with the costume of Superman, but when the party is arranged contest-buddies, he would go with the costume of ‘Chinese Postman’.

Since he is going to attend a number of parties on the Halloween night, and wear costumes accordingly, he will be changing his costumes a number of times. So, to make things a little easier, he may put on costumes one over another (that is he may wear the uniform for the postman, over the superman costume). Before each party he can take off some of the costumes, or wear a new one. That is, if he is wearing the Postman uniform over the Superman costume, and wants to go to a party in Superman costume, he can take off the Postman uniform, or he can wear a new Superman uniform. But, keep in mind that, Gappu doesn’t like to wear dresses without cleaning them first, so, after taking off the Postman uniform, he cannot use that again in the Halloween night, if he needs the Postman costume again, he will have to use a new one. He can take off any number of costumes, and if he takes off k of the costumes, that will be the last k ones (e.g. if he wears costume A before costume B, to take off A, first he has to remove B).

Given the parties and the costumes, find the minimum number of costumes Gappu will need in the Halloween night.

Input starts with an integer T (≤ 200), denoting the number of test cases.
Each case starts with a line containing an integer N (1 ≤ N ≤ 100) denoting the number of parties. Next line contains N integers, where the ith integer ci (1 ≤ ci ≤ 100) denotes the costume he will be wearing in party i. He will attend party 1 first, then party 2, and so on.

For each case, print the case number and the minimum number of required costumes.

样例输入

2

4

1 2 1 2

7

1 2 1 1 3 2 1

输出

Case 1: 3
Case 2: 4

中文:

你要参加一串舞会,参加不同的舞会需要穿不同的礼服,你穿礼服可以像套娃一样,外面套好多层,不过脱下来的衣服就不能再穿上了,问你最少穿多少衣服可以参加所以的舞会。

代码:

//#include<bits/stdc++.h>
#include<iostream>
#include<algorithm>
#include<string>
#include<cstring>
using namespace std;
typedef long long ll;typedef pair<int,int> pii;
const int maxn = 105;
int a[maxn];
int dp[maxn][maxn];
int n;int dfs(int i,int j)
{if(j<i)return 0;if(i==j){dp[i][j]=1;return 1;}if(dp[i][j]>0)return dp[i][j];dp[i][j]=dfs(i,j-1)+1;for(int k=i;k<j;k++){if(a[k]==a[j])dp[i][j]=min(dp[i][j],dfs(i,k)+dfs(k+1,j-1));}return dp[i][j];
}
int t;
int main()
{ios::sync_with_stdio(false);cin>>t;int k =0;while(t--){memset(dp,0,sizeof(dp));cin>>n;for(int i=1;i<=n;i++)cin>>a[i];int ans = dfs(1,n);cout<<"Case "<<++k<<": "<<ans<<endl;}return 0;
}

思路:

kuangbing大神的区间dp练习场,说啥也没看出这题怎么用区间的关系来描述状态。不得不说匡神的题目质量还真是高。

既然都说是区间dp了,肯定是用两个下标来描述一段区间的状态

设置 d p [ i ] [ j ] dp[i][j] dp[i][j]表示参加第i场舞会到第j场舞会所需要带的最少衣服

此题容易给人一种错觉,由于参加舞会是第一个到最后一个依次参加,很容易让人想到DAG模型,如果使用区间模型,那么如何保证当前描述的区间状态的最优解,是不受到序列顺序的影响呢?

一般的区间dp,考虑决策方向都是可以从两个方向考虑的,即下标i和下标j,这也是一个思维误区,认为区间动态规划的状态转移,需要能给够在两个方向上进行。其实不是这样, 区间dp也同样只可以在同一个方向上进行状态转移,以上一个区间作为候选状态,向前递推。

那么本题目的状态转移方程可以表示为

如果参加第j个舞会,选择直接穿上一件第j个舞会要求的礼服
d p [ i ] [ j ] = m i n ( d p [ i ] [ j ] , d p [ i ] [ j − 1 ] + 1 ) dp[i][j]=min(dp[i][j],dp[i][j-1]+1) dp[i][j]=min(dp[i][j],dp[i][j1]+1)

如果采用“套娃”式穿衣策略,此时枚举区间[i,j]中你参加过的第k个舞会,要求穿的礼服与第j个舞会的礼服相同,你可以在参加第j个舞会时,把参加[k+1,j-1]的舞会时的衣服脱掉
注意,此时的状态不应该是 d p [ i ] [ j ] = m i n ( d p [ i ] [ j ] , d p [ i ] [ k ] ) dp[i][j]=min(dp[i][j],dp[i][k]) dp[i][j]=min(dp[i][j],dp[i][k])
而是
d p [ i ] [ j ] = m i n ( d p [ i ] [ j ] , d p [ i ] [ k ] + d p [ k + 1 ] [ j − 1 ] ) dp[i][j]=min(dp[i][j],dp[i][k]+dp[k+1][j-1]) dp[i][j]=min(dp[i][j],dp[i][k]+dp[k+1][j1])
因为你参加[k+1,j-1]个舞会的时候也要穿礼服,这也是为什么要用区间模型的原因

这篇关于LightOJ 1422 Halloween Costumes的文章就介绍到这儿,希望我们推荐的文章对编程师们有所帮助!



http://www.chinasem.cn/article/840894

相关文章

poj 1422 Air Raid(最小路径覆盖 + 二分图最大匹配)

http://poj.org/problem?id=1422 题意:在一个有向无环图中,从一些顶点出发,能遍历到图上所有点,要求初始选择的顶点数最少且顶点不重复遍历。 思路: 如果从某个顶点开始遍历的过程看成是路径的选择,那么问题就转化为在有向无环图中找最少的不想交的简单路径,这些路径覆盖图中的所有顶点。可见是关于最小路径覆盖的问题。 在有向无环图中,最小路径覆盖数  =

LightOJ 1068 Investigation (数位dp)

http://www.lightoj.com/volume_showproblem.php?problem=1068 求出区间[A,B]内能被K整除且各位数字之和也能被K整除的数的个数。(1 ≤ A ≤ B < 231 and 0 < K < 10000) 算是最简单的数位dp了,k在这里是10000,三维数组都开不开。但是想想会发现A,B最多有10位,各位数字之和不会超过90,那么当

lightoj 1050 - Marbles (概率DP)

思路:定义dp[i][j] 为 袋子中有i个红球和j个红球时获胜的概率 那么根据题意我只可以任意拿而对手只拿蓝球。那么 dp[i][j] = (拿到红球的概率) * dp[i-1][j-1] + (拿到蓝球的概率) * dp[i][j-2]; 边界:当红球没有时,获胜的概率为1 注意点:T比较大,需要把所有数据预处理出来直接查询,否则超时 /*********************

lightoj 1047 Neighbor House(Dp)

思路:定义dp[i][j] 为粉刷第i个房子用的颜色j dp[i][j] = min(dp[i-1][(j+1)%3] , dp[i-1][(j+2) % 3]); 一共有三种颜色{0, 1, 2},任取一种颜色{j},那么和颜色j不同的颜色就为{(j + 1) % 3 , (j + 2) % 3}; /******************************************

lightoj 1044 Palindrome Partitioning(dp)

题意:给定字符串S,问可以划分的最小回文串数量 思路:定义dp[i]为以i开头的字符串中回文串的最小划分数. dp[i] = min(dp[j] + 1 | i <= j < n && S[i...j]是回文串) 边界,dp[i] = n-i+1. /************************************************ Author: fisty* Crea

lightoj 1037 - Agent 47 (状压DP)

题意:你现在需要消灭n个敌人,n个敌人的血量已知,你的普通攻击力为1,但是如果你杀死敌人i可以用它的武器去杀死其他敌人,p[i][j] 表示用敌人i的武器射杀敌人j会减p[i][j]滴血.问你最少可以攻击多少次可以将敌人杀死。 思路: 定义集合s为死亡敌人的集合。 dp[s] 为让集合为s的人死亡最小需要的攻击次数。 如果现在想要消灭敌人i 并且敌人i不属于s 那么dp[s | (1<<

lightoj 1032 - Fast Bit Calculations (数位DP)

记忆花搜索:dp[len][num][last] : 现在处理第len位,前面有num个11,并且最后一位为last。 /************************************************ Author: fisty* Created Time: 2015-08-18 20:18:09* File Name : 1032.cpp***************

[LightOJ 1292] Laser Shot (几何,判断共线)

LightOJ - 1292 刚开始写的时候是O( n3log(n) n^3log(n))的,枚举两个点,得到一条直线,用set记录下来,然后再 O( n n)地计数,居然没有卡过 orz 听了学长的教导,get到一个几何常用思路,正确解法如下 枚举一个点,再枚举其他点,计算到这个点的斜率,make_pair(dx,dy)塞到map里,把相同斜率的计数一下 这样时间复杂度为 O(n2log

[LightOJ 1364] Expected Cards (高维期望DP)

LightOJ - 1364 一副扑克牌,不断地从中抽牌 要求四种花色都至少要有给定的张数 其中如果抽到了王牌,可以将其变为任意花色 求满足条件时,抽出的期望张数 刚开始想错了,两张王牌并非在一开始就给定了 而是在游戏中可以视当前情况选择着变的 这两种方式是不一样的 由于牌数其实并不会很多, 复杂度乘一乘发现才 107 10^7级别的,所以直接暴力DP 将两张王牌当

[LightOJ 1342] Aladdin and the Magical Sticks (期望的线性性质+几何分布+邮票收集问题)

LightOJ - 1342 有 N根棍子,每根棍子都有一个权值 其中有若干根可识别的,若干根不可识别的 抽到了可识别的棍子,就不放回,抽到了不可识别的,就要放回 问所有棍子都至少被抽过一次后的期望权值和 根据期望的线性性, E(CX)=CE(X) E(CX) = CE(X) 所以可以对每根棍子求一下它被抽到的期望次数,再乘以它的权值 对于不可识别的棍子,由于它被抽到的概率